Create a FeaturePython object part II/fr: Difference between revisions

From FreeCAD Documentation
(Created page with "Jusqu'à présent, nous n'avons pas abordé explicitement le piégeage d'événements. Presque toutes les méthodes d'une classe FeaturePython servent de rappel accessible à...")
(Updating to match new version of source page)
(12 intermediate revisions by 3 users not shown)
Line 1: Line 1:
<languages/>
<languages/>


<div class="mw-translate-fuzzy">
{{docnav/fr
{{docnav/fr
|[[FeaturePython Objects/fr|Objects FeaturePython]]
|[[FeaturePython Objects/fr|Objects FeaturePython]]
|[[Scripting examples/fr|Exemples de Scripts]]
|[[Scripting examples/fr|Exemples de Scripts]]
}}
}}
</div>


{{TOCright}}

<div class="mw-translate-fuzzy">
=== App::FeaturePython vs. Part::FeaturePython ===
=== App::FeaturePython vs. Part::FeaturePython ===
</div>


<div class="mw-translate-fuzzy">
Jusqu'à présent, nous nous sommes concentrés sur les aspects internes d'une classe Python construite autour d'un objet FeaturePython - en particulier, un objet App::FeaturePython object.<br>
Jusqu'à présent, nous nous sommes concentrés sur les aspects internes d'une classe Python construite autour d'un objet FeaturePython - en particulier, un objet App::FeaturePython object.<br>
Nous avons créé l'objet, défini certaines propriétés et ajouté des rappels d'événements au niveau du document qui permettent à notre objet de répondre à un recalcul de document avec la méthode {{incode|execute()}}.
Nous avons créé l'objet, défini certaines propriétés et ajouté des rappels d'événements au niveau du document qui permettent à notre objet de répondre à un recalcul de document avec la méthode {{incode|execute()}}.
</div>


==Adding a box==

<div class="mw-translate-fuzzy">
'''Mais nous n'avons toujours pas de boîte.'''
'''Mais nous n'avons toujours pas de boîte.'''
</div>


{{Code|code=
Cependant, nous pouvons facilement en créer une en ajoutant seulement deux lignes.
import Part
}}


Then in {{incode|execute()}} delete the {{incode|print()}} statement and add the following line in its place:
Tout d'abord, ajoutez une nouvelle importation en haut du fichier: {{incode|import Part}}

Ensuite, dans {{incode|execute()}}, ajoutez la ligne suivante (vous pouvez supprimer l'instruction {{incode|print()}}):


{{Code|code=
{{Code|code=
Part.show(Part.makeBox(obj.Length, obj.Width, obj.Height))
def execute():
"""
Called on document recompute
"""

Part.show(Part.makeBox(obj.Length, obj.Width, obj.Height)
}}
}}


[[Image:App_featurepython_box.png | right]]

<div class="mw-translate-fuzzy">
Ces commandes exécutent des scripts python fournis avec FreeCAD par défaut.
Ces commandes exécutent des scripts python fournis avec FreeCAD par défaut.
* La méthode {{incode|makeBox()}} génère une nouvelle forme de boîte.
* La méthode {{incode|makeBox()}} génère une nouvelle forme de boîte.
* L'appel englobant à {{incode|Part.show()}} ajoute la forme à l'arborescence du document et la rend visible.
* L'appel englobant à {{incode|Part.show()}} ajoute la forme à l'arborescence du document et la rend visible.
</div>


<div class="mw-translate-fuzzy">
Si FreeCAD est ouvert, rechargez le module boîte et créez un nouvel objet boîte en utilisant {{incode|box.create()}} (supprimez tous les objets boîte existants, juste pour garder les choses propres).
Si FreeCAD est ouvert, rechargez le module boîte et créez un nouvel objet boîte en utilisant {{incode|box.create()}} (supprimez tous les objets boîte existants, juste pour garder les choses propres).
</div>


<div class="mw-translate-fuzzy">
Remarquez comment une boîte apparaît immédiatement à l'écran: la méthode {{incode|execute()}} est appelée immédiatement après la création de la boîte et nous forçons le document à recalculer à la fin de {{incode|box.create()}}.


[[File:App_featurepython_box.png]]

'''Mais il y a un problème.'''

Cela devrait être assez évident. La boîte elle-même est représentée par un objet entièrement différent de notre objet FeaturePython. La raison en est que {{incode|Part.show()}} crée un objet boîte séparé et l'ajoute au document. En fait, si vous accédez à votre objet FeaturePython et modifiez les dimensions, vous verrez une autre forme de boîte créée et l'ancienne laissée en place. Ce n'est pas bon! De plus, si la vue du rapport est ouverte, vous pouvez remarquer une erreur indiquant 'Les recalculs imbriqués d'un document ne sont pas autorisés'. Cela a à voir avec l'utilisation de la méthode Part.show() dans un objet FeaturePython. Nous voulons éviter de faire cela.
Cela devrait être assez évident. La boîte elle-même est représentée par un objet entièrement différent de notre objet FeaturePython. La raison en est que {{incode|Part.show()}} crée un objet boîte séparé et l'ajoute au document. En fait, si vous accédez à votre objet FeaturePython et modifiez les dimensions, vous verrez une autre forme de boîte créée et l'ancienne laissée en place. Ce n'est pas bon! De plus, si la vue du rapport est ouverte, vous pouvez remarquer une erreur indiquant 'Les recalculs imbriqués d'un document ne sont pas autorisés'. Cela a à voir avec l'utilisation de la méthode Part.show() dans un objet FeaturePython. Nous voulons éviter de faire cela.
</div>


[[#top|top]]
'''Astuce'''


==Fixing the code==
Le problème est que nous nous appuyons sur les méthodes {{incode|Part.make*()}}, qui ne génèrent que des objets Part::Feature non paramétriques (formes simples et stupides), tout comme vous obtiendriez si vous copiez un objet paramétrique à l'aide de [[Part SimpleCopy/fr|Part Copie simple]].

Ce que nous voulons, bien sûr, est un objet boîte '''paramétrique''' qui redimensionne la boîte existante lorsque nous modifions ses propriétés. Nous pourrions supprimer l'objet Part::Feature précédent et le régénérer à chaque fois que nous modifions une propriété, mais nous avons encore deux objets à gérer - notre objet FeaturePython personnalisé et l'objet Part::Feature qu'il génère.


<div class="mw-translate-fuzzy">
'''Alors, comment pouvons-nous résoudre ce problème?'''
'''Alors, comment pouvons-nous résoudre ce problème?'''
</div>


{{Code|code=
Tout d'abord, nous devons utiliser le bon type d'objet.
obj = App.ActiveDocument.addObject('App::FeaturePython', obj_name)

}}
Jusqu'à présent, nous avons utilisé des objets {{incode|App::FeaturePython}}. Ils sont pas mal mais ils ne sont pas destinés à être utilisés comme objets de géométrie. Ils sont plutôt mieux utilisés comme objets de document qui ne nécessitent pas de représentation visuelle dans la vue 3D. Nous devons donc utiliser un objet {{incode|Part::FeaturePython}} à la place.


Dans {{incode|create()}}, modifiez la ligne suivante:

obj = App.ActiveDocument.addObject('App::FeaturePython', obj_name)


<div class="mw-translate-fuzzy">
pour lire:
pour lire:
</div>


{{Code|code=
obj = App.ActiveDocument.addObject('{{ColoredText||red|Part::FeaturePython}}', obj_name)
obj = App.ActiveDocument.addObject('Part::FeaturePython', obj_name)
}}


<div class="mw-translate-fuzzy">
Pour terminer les modifications dont nous avons besoin, la ligne suivante de la méthode {{incode|execute()}} doit être modifiée:
Pour terminer les modifications dont nous avons besoin, la ligne suivante de la méthode {{incode|execute()}} doit être modifiée:
</div>


{{Code|code=
Part.show(Part.makeBox(obj.Length, obj.Width, obj.Height))
Part.show(Part.makeBox(obj.Length, obj.Width, obj.Height))
}}


en:
en:


{{Code|code=
obj.Shape = Part.makeBox(obj.Length, obj.Width, obj.Height)
obj.Shape = Part.makeBox(obj.Length, obj.Width, obj.Height)

}}
Votre code devrait ressembler à ceci:

import FreeCAD as App
import Part
def create(obj_name):
"""
Object creation method
"""
obj = App.ActiveDocument.addObject('Part::FeaturePython', obj_name)
fpo = box(obj)
App.ActiveDocument.recompute()
return fpo
class box():
def __init__(self, obj):
"""
Default Constructor
"""
self.Type = 'box'
obj.addProperty('App::PropertyString', 'Description', 'Base', 'Box description').Description = ""
obj.addProperty('App::PropertyLength', 'Length', 'Dimensions', 'Box length').Length = 10.0
obj.addProperty('App::PropertyLength', 'Width', 'Dimensions', 'Box width').Width = '10 mm'
obj.addProperty('App::PropertyLength', 'Height', 'Dimensions', 'Box height').Height = '1 cm'
obj.Proxy = self
self.Object = obj
def execute(self, obj):
"""
Called on document recompute
"""
obj.Shape = Part.makeBox(obj.Length, obj.Width, obj.Height)


[[File:Part_featurepython_no_vp.png|right]]
[[File:Part_featurepython_no_vp.png|right]]


<div class="mw-translate-fuzzy">
Maintenant, enregistrez vos modifications et revenez à FreeCAD. Supprimez tous les objets existants, rechargez le module de boîte et créez un nouvel objet de boîte.
Maintenant, enregistrez vos modifications et revenez à FreeCAD. Supprimez tous les objets existants, rechargez le module de boîte et créez un nouvel objet de boîte.
</div>


[[#top|top]]
Les résultats peuvent sembler un peu mitigés. L'icône dans l'arborescence est différente - c'est une boîte, maintenant. Mais il n'y a pas de cube. Et l'icône est toujours grise!

Qu'est-il arrivé? Bien que nous ayons correctement créé notre forme de boîte et l'avons affectée à un objet {{incode|Part::FeaturePython}}, avant de pouvoir l'afficher dans notre vue 3D, nous devons attribuer un '''ViewProvider.'''


<div class="mw-translate-fuzzy">
=== Écrire un ViewProvider ===
=== Écrire un ViewProvider ===
</div>


<div class="mw-translate-fuzzy">
Un fournisseur de vues est le composant d'un objet qui lui permet d'avoir une représentation visuelle dans l'interface graphique - en particulier dans la vue 3D. FreeCAD utilise une structure d'application appelée 'vue du modèle' qui est conçue pour séparer les données (le 'modèle') de sa représentation visuelle (la «vue»). Si vous avez passé du temps à travailler avec FreeCAD en Python, vous en serez probablement déjà conscient grâce à l'utilisation de deux modules Python principaux: FreeCAD et FreeCADGui (souvent aliasés respectivement «App» et «Gui»).
Un fournisseur de vues est le composant d'un objet qui lui permet d'avoir une représentation visuelle dans l'interface graphique - en particulier dans la vue 3D. FreeCAD utilise une structure d'application appelée 'vue du modèle' qui est conçue pour séparer les données (le 'modèle') de sa représentation visuelle (la «vue»). Si vous avez passé du temps à travailler avec FreeCAD en Python, vous en serez probablement déjà conscient grâce à l'utilisation de deux modules Python principaux: FreeCAD et FreeCADGui (souvent aliasés respectivement «App» et «Gui»).
</div>


<div class="mw-translate-fuzzy">
Ainsi, notre implémentation de FeaturePython Box nécessite également ces éléments. Jusqu'à présent, nous nous sommes concentrés uniquement sur la partie «modèle», il est donc temps d'écrire la «vue». Heureusement, la plupart des implémentations de vues sont simples et nécessitent peu d'efforts pour écrire, au moins pour commencer. Voici un exemple de ViewProvider, emprunté et légèrement modifié de [https://github.com/FreeCAD/FreeCAD/blob/master/src/Mod/TemplatePyMod/FeaturePython.py]
Ainsi, notre implémentation de FeaturePython Box nécessite également ces éléments. Jusqu'à présent, nous nous sommes concentrés uniquement sur la partie «modèle», il est donc temps d'écrire la «vue». Heureusement, la plupart des implémentations de vues sont simples et nécessitent peu d'efforts pour écrire, au moins pour commencer. Voici un exemple de ViewProvider, emprunté et légèrement modifié de [https://github.com/FreeCAD/FreeCAD/blob/master/src/Mod/TemplatePyMod/FeaturePython.py]
</div>

{{Code|code=
class ViewProviderBox:


class ViewProviderBox:
def __init__(self, obj):
def __init__(self, obj):
"""
"""
Set this object to the proxy object of the actual view provider
Set this object to the proxy object of the actual view provider
"""
"""

obj.Proxy = self
obj.Proxy = self

def attach(self, obj):
def attach(self, obj):
"""
"""
Line 140: Line 120:
"""
"""
return
return

def updateData(self, fp, prop):
def updateData(self, fp, prop):
"""
"""
Line 146: Line 126:
"""
"""
return
return

def getDisplayModes(self,obj):
def getDisplayModes(self,obj):
"""
"""
Return a list of display modes.
Return a list of display modes.
"""
"""
return None
return []

def getDefaultDisplayMode(self):
def getDefaultDisplayMode(self):
"""
"""
Line 158: Line 138:
"""
"""
return "Shaded"
return "Shaded"

def setDisplayMode(self,mode):
def setDisplayMode(self,mode):
"""
"""
Line 166: Line 146:
"""
"""
return mode
return mode

def onChanged(self, vp, prop):
def onChanged(self, vp, prop):
"""
"""
Print the name of the property that has changed
Print the name of the property that has changed
"""
"""

App.Console.PrintMessage("Change property: " + str(prop) + "\n")
App.Console.PrintMessage("Change property: " + str(prop) + "\n")

def getIcon(self):
def getIcon(self):
"""
"""
Return the icon in XMP format which will appear in the tree view. This method is optional and if not defined a default icon is shown.
Return the icon in XMP format which will appear in the tree view. This method is optional and if not defined a default icon is shown.
"""
"""

return """
return """
/* XPM */
/* XPM */
static const char * ViewProviderBox_xpm[] = {
static const char * ViewProviderBox_xpm[] = {
"16 16 6 1",
"16 16 6 1",
" c None",
" c None",
". c #141010",
". c #141010",
"+ c #615BD2",
"+ c #615BD2",
"@ c #C39D55",
"@ c #C39D55",
"# c #000000",
"# c #000000",
"$ c #57C355",
"$ c #57C355",
" ........",
" ........",
" ......++..+..",
" ......++..+..",
Line 206: Line 186:
" ####### "};
" ####### "};
"""
"""

def __getstate__(self):
def __getstate__(self):
"""
"""
Line 212: Line 192:
"""
"""
return None
return None

def __setstate__(self,state):
def __setstate__(self,state):
""""
"""
Called during document restore.
Called during document restore.
""""
"""
return None
return None
}}


<div class="mw-translate-fuzzy">
Remarquez dans le code ci-dessus, nous définissons également une icône XMP pour cet objet. La conception d'icônes dépasse le cadre de ce didacticiel, mais les conceptions d'icônes de base peuvent être gérées à l'aide d'outils open source tels que [https://www.gimp.org GIMP], [https://krita.org/fr/ Krita] et [https://inkscape.org/ Inkscape]. La méthode getIcon est également facultative. S'il n'est pas fourni, FreeCAD fournira une icône par défaut.
Remarquez dans le code ci-dessus, nous définissons également une icône XMP pour cet objet. La conception d'icônes dépasse le cadre de ce didacticiel, mais les conceptions d'icônes de base peuvent être gérées à l'aide d'outils open source tels que [https://www.gimp.org GIMP], [https://krita.org/fr/ Krita] et [https://inkscape.org/ Inkscape]. La méthode getIcon est également facultative. S'il n'est pas fourni, FreeCAD fournira une icône par défaut.
</div>


<div class="mw-translate-fuzzy">

Sans un ViewProvider défini, nous devons maintenant l'utiliser pour donner à notre objet la possibilité de la visualisation.
Sans un ViewProvider défini, nous devons maintenant l'utiliser pour donner à notre objet la possibilité de la visualisation.
</div>


{{Code|code=
Revenez à la méthode {{incode|create()}} dans votre code et ajoutez ce qui suit vers la fin:

ViewProviderBox(obj.ViewObject)
ViewProviderBox(obj.ViewObject)
}}


<div class="mw-translate-fuzzy">
Cette instance de la classe ViewProvider personnalisée lui transmet le ViewObject intégré de FeaturePython. Le ViewObject ne fera rien sans notre implémentation de la classe personnalisée donc, quand la classe ViewProvider s'initialise, elle enregistre une référence à elle-même dans l'attribut ViewObject.Proxy de FeaturePython. De cette façon, lorsque FreeCAD a besoin de rendre notre Box visuellement, il peut trouver la classe ViewProvider pour le faire.
Cette instance de la classe ViewProvider personnalisée lui transmet le ViewObject intégré de FeaturePython. Le ViewObject ne fera rien sans notre implémentation de la classe personnalisée donc, quand la classe ViewProvider s'initialise, elle enregistre une référence à elle-même dans l'attribut ViewObject.Proxy de FeaturePython. De cette façon, lorsque FreeCAD a besoin de rendre notre Box visuellement, il peut trouver la classe ViewProvider pour le faire.
</div>


<div class="mw-translate-fuzzy">
Maintenant, enregistrez les modifications et revenez à FreeCAD. Importez ou rechargez le module Box et appelez {{incode|box.create()}}.
Maintenant, enregistrez les modifications et revenez à FreeCAD. Importez ou rechargez le module Box et appelez {{incode|box.create()}}.
</div>


[[#top|top]]
Nous ne voyons toujours rien, mais notez ce qui est arrivé à l'icône à côté de l'objet boîte. C'est en couleur! Et ça a une forme! C'est un indice que notre ViewProvider fonctionne comme prévu.

Alors maintenant, il est temps de réellement *ajouter* une boîte.

Revenez au code et ajoutez la ligne suivante à la méthode execute():

obj.Shape = Part.makeBox(obj.Length, obj.Width, obj.Height)

Maintenant, enregistrez, rechargez le module de boîte dans FreeCAD et créez une nouvelle boîte.

Vous devriez voir une boîte apparaître à l'écran! Si elle est trop grande (ou ne s'affiche pas du tout), cliquez sur l'un des boutons 'ViewFit' pour l'adapter à la vue 3D.

Notez ce que nous avons fait ici qui diffère de la façon dont il a été implémenté pour App::FeaturePython ci-dessus. Dans la méthode {{incode|execute()}}, nous avons appelé la macro {{incode|Part.makeBox()}} et lui avons transmis les propriétés de la boîte comme précédemment. Mais plutôt que d'appeler {{incode|Part.show()}} sur l'objet résultant (qui a créé un nouvel objet boîte séparé), nous l'avons simplement affecté à la propriété {{incode|Shape}} de notre Part::FeaturePython objet à la place.

Vous pouvez même modifier les dimensions de la boîte en modifiant les valeurs dans le panneau de propriétés FreeCAD. Essayez!


<div class="mw-translate-fuzzy">
=== Piégeage d'événements ===
=== Piégeage d'événements ===
</div>


<div class="mw-translate-fuzzy">
Jusqu'à présent, nous n'avons pas abordé explicitement le piégeage d'événements. Presque toutes les méthodes d'une classe FeaturePython servent de rappel accessible à l'objet FeaturePython (qui obtient l'accès à notre instance de classe via l'attribut {{incode|Proxy}}, si vous vous en souvenez).
Jusqu'à présent, nous n'avons pas abordé explicitement le piégeage d'événements. Presque toutes les méthodes d'une classe FeaturePython servent de rappel accessible à l'objet FeaturePython (qui obtient l'accès à notre instance de classe via l'attribut {{incode|Proxy}}, si vous vous en souvenez).
</div>


Voici une liste des rappels pouvant être implémentés dans l'objet FeaturePython de base:
Below is a list of the callbacks that may be implemented in the basic FeaturePython object:


{| class="wikitable"
{| class="wikitable" cellpadding="5px" width="100%"
|+ FeaturePython basic callbacks

|+style="caption-side:bottom; | FeaturePython basic callbacks
|style="width:25%" | {{incode|execute(self, obj)}}
|style="width:25%" | Called during document recomputes
|{{incode|execute(self, obj)}} || Called during document recomputes || Do not call {{incode|recompute()}} from this method (or any method called from {{incode|execute()}}) as this causes a nested recompute.
|style="width:50%" | Do not call {{incode|recompute()}} from this method (or any method called from {{incode|execute()}}) as this causes a nested recompute.
|-
|-
| {{incode|onBeforeChanged(self, obj, prop)}}
|{{incode|onBeforeChanged(self, obj, prop)}} || Called before a property value is changed || {{incode|prop}} is the name of the property to be changed, not the property object itself. Property changes cannot be cancelled. Previous / next property values are not simultaneously available for comparison.
| Called before a property value is changed
| {{incode|prop}} is the name of the property to be changed, not the property object itself. Property changes cannot be cancelled. Previous / next property values are not simultaneously available for comparison.
|-
|-
|{{incode|onChanged(self, obj, prop)}} || Called after a property is changed || {{incode|prop}} is the name of the property to be changed, not the property object itself.
| {{incode|onChanged(self, obj, prop)}}
| Called after a property is changed
| {{incode|prop}} is the name of the property to be changed, not the property object itself.
|-
|-
| {{Incode|onDocumentRestored(self, obj)}}
|{{Incode|onDocumentRestored(self, obj)}} || Called after a document is restored or aFeaturePython object is copied / duplicated. || Occasionally, references to the FeaturePython object from the class, or the class from the FeaturePython object may be broken, as the class {{incode|__init__()}} method is not called when the object is reconstructed. Adding {{incode|self.Object = obj}} or {{incode|obj.Proxy = self}} often solves these issues.
| Called after a document is restored or a FeaturePython object is copied.

| Occasionally, references to the FeaturePython object from the class, or the class from the FeaturePython object may be broken, as the class {{incode|__init__()}} method is not called when the object is reconstructed. Adding {{incode|self.Object <nowiki>=</nowiki> obj}} or {{incode|obj.Proxy <nowiki>=</nowiki> self}} often solves these issues.
|}
|}


En outre, il existe deux rappels dans la classe ViewProvider qui peuvent parfois s'avérer utiles:
In addition, there are two callbacks in the ViewProvider class that may occasionally prove useful:

{| class="wikitable"


{| class="wikitable" cellpadding="5px" width="100%"
|+style="caption-side:bottom; | ViewProvider basic callbacks
|+ ViewProvider basic callbacks
|-
|-
|style="width:25%" | {{incode|updateData(self, obj, prop)}}
|{{incode|updateData(self, obj, prop)}} || Called after a data (model) property is changed || {{incode|obj}} is a reference to the FeaturePython class instance, not the ViewProvider instance. {{incode|prop}} is the name of the property to be changed, not the property object itself.
|style="width:25%" | Called after a data (model) property is changed
|style="width:50%" | {{incode|obj}} is a reference to the FeaturePython class instance, not the ViewProvider instance. {{incode|prop}} is the name of the property to be changed, not the property object itself.
|-
|-
| {{incode|onChanged(self, vobj, prop)}}
|{{incode|onChanged(self, vobj, prop)}} || Called after a view property is changed || {{incode|vobj}} is a reference to the ViewProvider instance. {{incode|prop}} is the name of the view property which was changed.
| Called after a view property is changed
| {{incode|vobj}} is a reference to the ViewProvider instance. {{incode|prop}} is the name of the view property which was changed.
|}
|}


<div class="mw-translate-fuzzy">

{| class="wikitable"
!{{ColoredParagraph|Tip}}

|-
|-
|It is not uncommon to encounter a situation where the Python callbacks are not being triggered as they should. Beginners in this area need to rest assured that the FeaturePython callback system is not fragile or broken. Invariably, when callbacks fail to run, it is because a reference is lost or undefined in the underlying code. If, however, callbacks appear to be breaking with no explanation, providing object / proxy references in the {{incode|onDocumentRestored()}} callback (as noted in the first table above) may alleviate these problems. Until you are comfortable with the callback system, it may be useful to add print statements in each callback to print messages to the console as a diagnostic during development.
|Il n'est pas rare de rencontrer une situation les rappels Python ne sont pas déclenchés comme ils le devraient. Les débutants dans ce domaine doivent être assurés que le système de rappel FeaturePython n'est pas fragile ou cassé. Invariablement, lorsque les rappels ne s'exécutent pas, c'est parce qu'une référence est perdue ou indéfinie dans le code sous-jacent. Si, cependant, les rappels semblent rompre sans explication, la fourniture de références d'objet / proxy dans le rappel {{incode|onDocumentRestored()}} (comme indiqué dans le premier tableau ci-dessus) peut atténuer ces problèmes. Jusqu'à ce que vous soyez à l'aise avec le système de rappel, il peut être utile d'ajouter des instructions d'impression dans chaque rappel pour imprimer des messages sur la console comme diagnostic pendant le développement.
</div>


[[#top|top]]
|}


<div class="mw-translate-fuzzy">
=== The Code ===
=== Le code ===
</div>


{{Code|code=
The complete code for this example:
import FreeCAD as App
import Part


def create(obj_name):
import FreeCAD as App
import Part
def create(obj_name):
"""
"""
Object creation method
Object creation method
"""
"""

obj = App.ActiveDocument.addObject('Part::FeaturePython', obj_name)
obj = App.ActiveDocument.addObject('Part::FeaturePython', obj_name)

fpo = box(obj)
box(obj)

ViewProviderBox(obj.ViewObject)
ViewProviderBox(obj.ViewObject)

App.ActiveDocument.recompute()
App.ActiveDocument.recompute()

return fpo
return obj

class box():

class box():
def __init__(self, obj):
def __init__(self, obj):
"""
"""
Default Constructor
Default constructor
"""
"""

self.Type = 'box'
self.Type = 'box'

self.ratios = None
obj.addProperty('App::PropertyString', 'Description', 'Base', 'Box description').Description = 'Hello World!'
obj.addProperty('App::PropertyLength', 'Length', 'Dimensions', 'Box length').Length = 10.0
obj.addProperty('App::PropertyLength', 'Width', 'Dimensions', 'Box width'). Width = '10 mm'
obj.addProperty('App::PropertyLength', 'Height', 'Dimensions', 'Box Height').Height = '1 cm'
obj.addProperty('App::PropertyBool', 'Aspect Ratio', 'Dimensions', 'Lock the box aspect ratio').Aspect_Ratio = False
obj.Proxy = self
obj.Proxy = self

self.Object = obj
obj.addProperty('App::PropertyString', 'Description', 'Base', 'Box description').Description = ""
obj.addProperty('App::PropertyLength', 'Length', 'Dimensions', 'Box length').Length = 10.0
def __getstate__(self):
obj.addProperty('App::PropertyLength', 'Width', 'Dimensions', 'Box width').Width = '10 mm'
return self.Type
obj.addProperty('App::PropertyLength', 'Height', 'Dimensions', 'Box height').Height = '1 cm'

def __setstate__(self, state):
if state:
self.Type = state
def execute(self, obj):
def execute(self, obj):
"""
"""
Called on document recompute
Called on document recompute
"""
"""

obj.Shape = Part.makeBox(obj.Length, obj.Width, obj.Height)
obj.Shape = Part.makeBox(obj.Length, obj.Width, obj.Height)

class ViewProviderBox:

class ViewProviderBox:
def __init__(self, obj):
def __init__(self, obj):
"""
"""
Set this object to the proxy object of the actual view provider
Set this object to the proxy object of the actual view provider
"""
"""

obj.Proxy = self
obj.Proxy = self

def attach(self, obj):
def attach(self, obj):
"""
"""
Line 357: Line 332:
"""
"""
return
return

def updateData(self, fp, prop):
def updateData(self, fp, prop):
"""
"""
If a property of the handled feature has changed we have the chance to handle this here
If a property of the handled feature has changed we have the chance to handle this here
"""
"""
return
return

def getDisplayModes(self,obj):
def getDisplayModes(self,obj):
"""
"""
Return a list of display modes.
Return a list of display modes.
"""
"""
return None
return []

def getDefaultDisplayMode(self):
def getDefaultDisplayMode(self):
"""
"""
Line 376: Line 350:
"""
"""
return "Shaded"
return "Shaded"

def setDisplayMode(self,mode):
def setDisplayMode(self,mode):
"""
"""
Line 384: Line 358:
"""
"""
return mode
return mode

def onChanged(self, vobj, prop):
def onChanged(self, vp, prop):
"""
"""
Print the name of the property that has changed
Print the name of the property that has changed
"""
"""

App.Console.PrintMessage("Change property: " + str(prop) + "\n")
App.Console.PrintMessage("Change property: " + str(prop) + "\n")

def getIcon(self):
def getIcon(self):
"""
"""
Return the icon in XMP format which will appear in the tree view. This method is optional and if not defined a default icon is shown.
Return the icon in XMP format which will appear in the tree view. This method is optional and if not defined a default icon is shown.
"""
"""

return """
return """
/* XPM */
/* XPM */
static const char * ViewProviderBox_xpm[] = {
static const char * ViewProviderBox_xpm[] = {
"16 16 6 1",
"16 16 6 1",
" c None",
" c None",
". c #141010",
". c #141010",
"+ c #615BD2",
"+ c #615BD2",
"@ c #C39D55",
"@ c #C39D55",
"# c #000000",
"# c #000000",
"$ c #57C355",
"$ c #57C355",
" ........",
" ........",
" ......++..+..",
" ......++..+..",
Line 424: Line 398:
" ####### "};
" ####### "};
"""
"""

def __getstate__(self):
def __getstate__(self):
"""
Called during document saving.
"""
return None
return None

def __setstate__(self,state):
def __setstate__(self,state):
"""
Called during document restore.
"""
return None
return None
}}

[[#top|top]]


<div class="mw-translate-fuzzy">
{{docnav/fr
{{docnav/fr
|[[FeaturePython Objects/fr|Objects FeaturePython]]
|[[FeaturePython Objects/fr|Objects FeaturePython]]
|[[Scripting examples/fr|Exemples de Scripts]]
|[[Scripting examples/fr|Exemples de Scripts]]
}}
}}
</div>


{{Powerdocnavi{{#translation:}}}}
{{Userdocnavi/fr}}
[[Category:Developer Documentation{{#translation:}}]]

[[Category:Tutorials/fr]]
[[Category:Python Code{{#translation:}}]]
{{clear}}

[[Category:Python Code/fr]]

[[Category:Poweruser Documentation/fr]]

Revision as of 11:00, 9 June 2020

Other languages:

App::FeaturePython vs. Part::FeaturePython

Jusqu'à présent, nous nous sommes concentrés sur les aspects internes d'une classe Python construite autour d'un objet FeaturePython - en particulier, un objet App::FeaturePython object.
Nous avons créé l'objet, défini certaines propriétés et ajouté des rappels d'événements au niveau du document qui permettent à notre objet de répondre à un recalcul de document avec la méthode execute().

Adding a box

Mais nous n'avons toujours pas de boîte.

import Part

Then in execute() delete the print() statement and add the following line in its place:

Part.show(Part.makeBox(obj.Length, obj.Width, obj.Height))

Ces commandes exécutent des scripts python fournis avec FreeCAD par défaut.

  • La méthode makeBox() génère une nouvelle forme de boîte.
  • L'appel englobant à Part.show() ajoute la forme à l'arborescence du document et la rend visible.

Si FreeCAD est ouvert, rechargez le module boîte et créez un nouvel objet boîte en utilisant box.create() (supprimez tous les objets boîte existants, juste pour garder les choses propres).

Cela devrait être assez évident. La boîte elle-même est représentée par un objet entièrement différent de notre objet FeaturePython. La raison en est que Part.show() crée un objet boîte séparé et l'ajoute au document. En fait, si vous accédez à votre objet FeaturePython et modifiez les dimensions, vous verrez une autre forme de boîte créée et l'ancienne laissée en place. Ce n'est pas bon! De plus, si la vue du rapport est ouverte, vous pouvez remarquer une erreur indiquant 'Les recalculs imbriqués d'un document ne sont pas autorisés'. Cela a à voir avec l'utilisation de la méthode Part.show() dans un objet FeaturePython. Nous voulons éviter de faire cela.

top

Fixing the code

Alors, comment pouvons-nous résoudre ce problème?

obj = App.ActiveDocument.addObject('App::FeaturePython', obj_name)

pour lire:

obj = App.ActiveDocument.addObject('Part::FeaturePython', obj_name)

Pour terminer les modifications dont nous avons besoin, la ligne suivante de la méthode execute() doit être modifiée:

Part.show(Part.makeBox(obj.Length, obj.Width, obj.Height))

en:

obj.Shape = Part.makeBox(obj.Length, obj.Width, obj.Height)

Maintenant, enregistrez vos modifications et revenez à FreeCAD. Supprimez tous les objets existants, rechargez le module de boîte et créez un nouvel objet de boîte.

top

Écrire un ViewProvider

Un fournisseur de vues est le composant d'un objet qui lui permet d'avoir une représentation visuelle dans l'interface graphique - en particulier dans la vue 3D. FreeCAD utilise une structure d'application appelée 'vue du modèle' qui est conçue pour séparer les données (le 'modèle') de sa représentation visuelle (la «vue»). Si vous avez passé du temps à travailler avec FreeCAD en Python, vous en serez probablement déjà conscient grâce à l'utilisation de deux modules Python principaux: FreeCAD et FreeCADGui (souvent aliasés respectivement «App» et «Gui»).

Ainsi, notre implémentation de FeaturePython Box nécessite également ces éléments. Jusqu'à présent, nous nous sommes concentrés uniquement sur la partie «modèle», il est donc temps d'écrire la «vue». Heureusement, la plupart des implémentations de vues sont simples et nécessitent peu d'efforts pour écrire, au moins pour commencer. Voici un exemple de ViewProvider, emprunté et légèrement modifié de [1]

class ViewProviderBox:

    def __init__(self, obj):
        """
        Set this object to the proxy object of the actual view provider
        """

        obj.Proxy = self

    def attach(self, obj):
        """
        Setup the scene sub-graph of the view provider, this method is mandatory
        """
        return

    def updateData(self, fp, prop):
        """
        If a property of the handled feature has changed we have the chance to handle this here
        """
        return

    def getDisplayModes(self,obj):
        """
        Return a list of display modes.
        """
        return []

    def getDefaultDisplayMode(self):
        """
        Return the name of the default display mode. It must be defined in getDisplayModes.
        """
        return "Shaded"

    def setDisplayMode(self,mode):
        """
        Map the display mode defined in attach with those defined in getDisplayModes.
        Since they have the same names nothing needs to be done.
        This method is optional.
        """
        return mode

    def onChanged(self, vp, prop):
        """
        Print the name of the property that has changed
        """

        App.Console.PrintMessage("Change property: " + str(prop) + "\n")

    def getIcon(self):
        """
        Return the icon in XMP format which will appear in the tree view. This method is optional and if not defined a default icon is shown.
        """

        return """
            /* XPM */
            static const char * ViewProviderBox_xpm[] = {
            "16 16 6 1",
            "    c None",
            ".   c #141010",
            "+   c #615BD2",
            "@   c #C39D55",
            "#   c #000000",
            "$   c #57C355",
            "        ........",
            "   ......++..+..",
            "   .@@@@.++..++.",
            "   .@@@@.++..++.",
            "   .@@  .++++++.",
            "  ..@@  .++..++.",
            "###@@@@ .++..++.",
            "##$.@@$#.++++++.",
            "#$#$.$$$........",
            "#$$#######      ",
            "#$$#$$$$$#      ",
            "#$$#$$$$$#      ",
            "#$$#$$$$$#      ",
            " #$#$$$$$#      ",
            "  ##$$$$$#      ",
            "   #######      "};
            """

    def __getstate__(self):
        """
        Called during document saving.
        """
        return None

    def __setstate__(self,state):
        """
        Called during document restore.
        """
        return None

Remarquez dans le code ci-dessus, nous définissons également une icône XMP pour cet objet. La conception d'icônes dépasse le cadre de ce didacticiel, mais les conceptions d'icônes de base peuvent être gérées à l'aide d'outils open source tels que GIMP, Krita et Inkscape. La méthode getIcon est également facultative. S'il n'est pas fourni, FreeCAD fournira une icône par défaut.

Sans un ViewProvider défini, nous devons maintenant l'utiliser pour donner à notre objet la possibilité de la visualisation.

ViewProviderBox(obj.ViewObject)

Cette instance de la classe ViewProvider personnalisée lui transmet le ViewObject intégré de FeaturePython. Le ViewObject ne fera rien sans notre implémentation de la classe personnalisée donc, quand la classe ViewProvider s'initialise, elle enregistre une référence à elle-même dans l'attribut ViewObject.Proxy de FeaturePython. De cette façon, lorsque FreeCAD a besoin de rendre notre Box visuellement, il peut trouver la classe ViewProvider pour le faire.

Maintenant, enregistrez les modifications et revenez à FreeCAD. Importez ou rechargez le module Box et appelez box.create().

top

Piégeage d'événements

Jusqu'à présent, nous n'avons pas abordé explicitement le piégeage d'événements. Presque toutes les méthodes d'une classe FeaturePython servent de rappel accessible à l'objet FeaturePython (qui obtient l'accès à notre instance de classe via l'attribut Proxy, si vous vous en souvenez).

Voici une liste des rappels pouvant être implémentés dans l'objet FeaturePython de base:

FeaturePython basic callbacks
execute(self, obj) Called during document recomputes Do not call recompute() from this method (or any method called from execute()) as this causes a nested recompute.
onBeforeChanged(self, obj, prop) Called before a property value is changed prop is the name of the property to be changed, not the property object itself. Property changes cannot be cancelled. Previous / next property values are not simultaneously available for comparison.
onChanged(self, obj, prop) Called after a property is changed prop is the name of the property to be changed, not the property object itself.
onDocumentRestored(self, obj) Called after a document is restored or a FeaturePython object is copied. Occasionally, references to the FeaturePython object from the class, or the class from the FeaturePython object may be broken, as the class __init__() method is not called when the object is reconstructed. Adding self.Object = obj or obj.Proxy = self often solves these issues.

En outre, il existe deux rappels dans la classe ViewProvider qui peuvent parfois s'avérer utiles:

ViewProvider basic callbacks
updateData(self, obj, prop) Called after a data (model) property is changed obj is a reference to the FeaturePython class instance, not the ViewProvider instance. prop is the name of the property to be changed, not the property object itself.
onChanged(self, vobj, prop) Called after a view property is changed vobj is a reference to the ViewProvider instance. prop is the name of the view property which was changed.

|- |Il n'est pas rare de rencontrer une situation où les rappels Python ne sont pas déclenchés comme ils le devraient. Les débutants dans ce domaine doivent être assurés que le système de rappel FeaturePython n'est pas fragile ou cassé. Invariablement, lorsque les rappels ne s'exécutent pas, c'est parce qu'une référence est perdue ou indéfinie dans le code sous-jacent. Si, cependant, les rappels semblent rompre sans explication, la fourniture de références d'objet / proxy dans le rappel onDocumentRestored() (comme indiqué dans le premier tableau ci-dessus) peut atténuer ces problèmes. Jusqu'à ce que vous soyez à l'aise avec le système de rappel, il peut être utile d'ajouter des instructions d'impression dans chaque rappel pour imprimer des messages sur la console comme diagnostic pendant le développement.

top

Le code

import FreeCAD as App
import Part

def create(obj_name):
    """
    Object creation method
    """

    obj = App.ActiveDocument.addObject('Part::FeaturePython', obj_name)

    box(obj)

    ViewProviderBox(obj.ViewObject)

    App.ActiveDocument.recompute()

    return obj

class box():

    def __init__(self, obj):
        """
        Default constructor
        """

        self.Type = 'box'

        obj.Proxy = self

        obj.addProperty('App::PropertyString', 'Description', 'Base', 'Box description').Description = ""
        obj.addProperty('App::PropertyLength', 'Length', 'Dimensions', 'Box length').Length = 10.0
        obj.addProperty('App::PropertyLength', 'Width', 'Dimensions', 'Box width').Width = '10 mm'
        obj.addProperty('App::PropertyLength', 'Height', 'Dimensions', 'Box height').Height = '1 cm'

    def execute(self, obj):
        """
        Called on document recompute
        """

        obj.Shape = Part.makeBox(obj.Length, obj.Width, obj.Height)

class ViewProviderBox:

    def __init__(self, obj):
        """
        Set this object to the proxy object of the actual view provider
        """

        obj.Proxy = self

    def attach(self, obj):
        """
        Setup the scene sub-graph of the view provider, this method is mandatory
        """
        return

    def updateData(self, fp, prop):
        """
        If a property of the handled feature has changed we have the chance to handle this here
        """
        return

    def getDisplayModes(self,obj):
        """
        Return a list of display modes.
        """
        return []

    def getDefaultDisplayMode(self):
        """
        Return the name of the default display mode. It must be defined in getDisplayModes.
        """
        return "Shaded"

    def setDisplayMode(self,mode):
        """
        Map the display mode defined in attach with those defined in getDisplayModes.
        Since they have the same names nothing needs to be done.
        This method is optional.
        """
        return mode

    def onChanged(self, vp, prop):
        """
        Print the name of the property that has changed
        """

        App.Console.PrintMessage("Change property: " + str(prop) + "\n")

    def getIcon(self):
        """
        Return the icon in XMP format which will appear in the tree view. This method is optional and if not defined a default icon is shown.
        """

        return """
            /* XPM */
            static const char * ViewProviderBox_xpm[] = {
            "16 16 6 1",
            "    c None",
            ".   c #141010",
            "+   c #615BD2",
            "@   c #C39D55",
            "#   c #000000",
            "$   c #57C355",
            "        ........",
            "   ......++..+..",
            "   .@@@@.++..++.",
            "   .@@@@.++..++.",
            "   .@@  .++++++.",
            "  ..@@  .++..++.",
            "###@@@@ .++..++.",
            "##$.@@$#.++++++.",
            "#$#$.$$$........",
            "#$$#######      ",
            "#$$#$$$$$#      ",
            "#$$#$$$$$#      ",
            "#$$#$$$$$#      ",
            " #$#$$$$$#      ",
            "  ##$$$$$#      ",
            "   #######      "};
            """

    def __getstate__(self):
        """
        Called during document saving.
        """
        return None

    def __setstate__(self,state):
        """
        Called during document restore.
        """
        return None

top